; Enemy projectile routines

ENEMYPROJ = 10

ClearEnemyProj:
 ld hl,EnemyProj
 ld de,EnemyProj+1
 ld bc,(ENEMYPROJ*3)-1
 ld (hl),-1
 ldir
 ret
 
; de = coords, a = dir
AddEnemyProj:
 ld (_@AddEnemyProjDir),a
 ld hl,ProjectileOffsetTable
 ld b,0
 add a,a
 ld c,a
 add hl,bc
 ld a,(hl)
 add a,e
 ld e,a
 inc hl
 ld a,(hl)
 add a,d
 ld d,a
 ld (_@AddEnemyProjCoords),de
 ld hl,EnemyProj
 ld de,3
 ld b,ENEMYPROJ
 ld a,-1
AddEnemyProjLoop:
 cp (hl)
 jr z,AddEnemyProjFound
 add hl,de
 djnz AddEnemyProjLoop
 ret
AddEnemyProjFound:
 ld a,0
_@AddEnemyProjDir =$-1
 ld (hl),a
 inc hl
_@AddEnemyProjCoords =$+1
 ld bc,$ffff
 ld (hl),c
 inc hl
 ld (hl),b
 ret

UpdateEnemyProj:
 ld b,ENEMYPROJ
 ld hl,EnemyProj
UpdateEnemyProjFind:
 ld a,(hl)
 cp -1
 call nz,UpdateEnemyProjDo
 inc hl
 inc hl
 inc hl
 djnz UpdateEnemyProjFind
 ret
UpdateEnemyProjDo:
 push hl
 push bc
 ld (_@UpdateEnemyProjDoDir),a
 inc hl
 ld c,(hl)
 inc hl
 ld b,(hl)
 call GetTileCentClip
 jr nc,UpdateEnemyProjDoOk
UpdateEnemyProjDoKill:
 dec hl
 dec hl
 ld (hl),-1
 jr UpdateEnemyProjDoDone
UpdateEnemyProjDoOk:
 ld de,(PlayerY)
 call CheckPoint
 jr c,UpdateEnemyProjMove
 push hl
 ld a,(_@UpdateEnemyProjDoDir)
 call HurtPlayerDir
 pop hl
 jr UpdateEnemyProjDoKill
UpdateEnemyProjMove:
 ld a,0
_@UpdateEnemyProjDoDir =$-1
 ex de,hl
 ld b,0
 add a,a
 ld c,a
 ld hl,DirTableCoords2
 add hl,bc
 ld a,(de)
 add a,(hl)
 ld (de),a
 ld b,a
 dec de
 inc hl
 ld a,(de)
 add a,(hl)
 ld (de),a
 ld c,a 
 ld hl,EnemyProjSpr
 ld a,(Frame)
 rra
 jr c,UpdateEnemyProjDraw
 ld hl,EnemyProjSpr2
UpdateEnemyProjDraw:
 call GraySpriteClip 
UpdateEnemyProjDoDone:
 pop bc
 pop hl
 ret

EnemyProjSpr:
	.db %01000000
	.db %10100000
	.db %01000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

EnemyProjSpr2:
	.db %10100000
	.db %01000000
	.db %10100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %11100000
	.db %11100000
	.db %11100000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000
	.db %00000000

.end
